<?php
  
  /**
	* Checkpoints Live plugin by Lambda (hello.lambda@yahoo.com) 
	* test plugin v2.0.4 - XAseco(v1.11) Time Attack mode
	* 21-jul-2010, tested on PHP v5.3.1 Linux
	* fixed bug with the numeric login
	* 08-avg-2010 -> v2.0.5
	* htmlspecialchars
	* replace red and green arrows with icons (bug on Windows server machine xy? ([M&C]Chris))
	* 22-jul-2012
	* change icons URL
	**/
  
  global $num_rows, $xframe, $yframe, $ml_id, $ml_pl, $manialinkvisible, $bck_quad;
  global $colour1, $colour2, $colour3, $colour4, $colour5, $colour6, $colour7, $colour8;
  global $answer_1, $answer_2;
  global $add_to_login;
  
  //*** CONFIGURATION ***//

  //number of displayed rows
  $num_rows = 12;			//12-15 players works fine
  
  //frame position - under TV (spec)
  $xframe = -64.4;			//horizontal (-64.4)
  $yframe = 22.7;			//vertical (22.7)
  $ml_id = 1928378;			//manialink Title ID
  $ml_pl = 1;				//+ manialink Players ID
  $answer_1 = '01928392';	//ManialinkPageAnswer ID
  $answer_2 = '01928394';	//ManialinkPageAnswer ID
  $manialinkvisible = 1;	//Manialink when Player connect: 1 = unhide, 0 = hide
  $bck_quad = False;		//background quad (true = quad, false = no quad)
  $add_to_login = '_';		//login prefix
  
  //colors
  $colour1 = 'FFE';    //Title Checkpoints Live    
  $colour2 = 'ABC';    //Track text
  $colour3 = '9B1';    //Track numbers
  $colour4 = '567';    //Position number
  $colour5 = 'F93';    //CP- Text
  $colour6 = 'F93';    //cp's numbers
  $colour7 = 'FFC';    //Time
  $colour8 = 'FFE';    //Title CP Live

  //*** END CONFIGURATION ***//  
  
  Aseco::registerEvent('onSync', 'cplive_control_start');
  Aseco::registerEvent('onRestartChallenge', 'cplive_restart');
  Aseco::registerEvent('onPlayerConnect', 'cplive_player_on');
  Aseco::registerEvent('onCheckpoint', 'cplive_get_cp');  
  Aseco::registerEvent('onPlayerFinish', 'cplive_give_up');
  Aseco::registerEvent('onPlayerManialinkPageAnswer', 'cplive_player_answer_hs');
  Aseco::registerEvent('onPlayerInfoChanged', 'cplive_player_afk_spec');
  Aseco::registerEvent('onEndRound', 'cplive_list_cp_end');
  Aseco::registerEvent('onBeginRound', 'cplive_reset_all');
  Aseco::registerEvent('onPlayerDisconnect', 'cplive_player_off');
  
  global $Players, $CpNb, $list, $List, $all_cps, $mlink_id;
  
  $Players = array();
  $CpNb = array();
  $mlink_id = $ml_id + $ml_pl; 

  //onSync
  function cplive_control_start($lambda){  
	get_cps($lambda);
  }
    
  //onRestartChallenge
  function cplive_restart($lambda){	
	cplive_list_cp_end($lambda);
  }
  
  //onPlayerConnect
  function cplive_player_on($lambda, $ondata){
	global $Players, $CpNb, $manialinkvisible;
  	global $add_to_login;
	
	$login = $ondata->login . $add_to_login;    
	$nickname = htmlspecialchars($ondata->nickname);
	if (is_string($login)){
		$Players[$login] = array("Nickname" => $nickname,
						"Manialink" => $manialinkvisible);       
    
		//default value
		$CpNb[$login] = array("CPNumber" => 0,
							"Time" => '');
						  
		//check if value exist (?!)
		if(!in_array($nickname, $Players[$login], true)){
			unset($Players[$login]);
			unset($CpNb[$login]);    
		}
		cplive_list($lambda);
	}                           
  }
  	
  //onCheckpoint
  function cplive_get_cp($lambda, $cpdata){ 
    global $Players, $CpNb;
	global $add_to_login;

	$login = $cpdata[1] . $add_to_login;
    
	$CpNb[$login] = array("CPNumber" => $cpdata[4]+1, 
						"Time" => $cpdata[2]);    
    	
    if(!array_key_exists($login, $CpNb)){
        unset($Players[$login]);
        unset($CpNb[$login]);    
    }	
	cplive_list($lambda);
  }

  //onPlayerFinish
  function cplive_give_up($lambda, $finish){  
	global $Players, $CpNb;
	global $add_to_login;
	
	//player give up
	$login = $finish->player->login . $add_to_login;
	$cps = $finish->challenge->nbchecks;

	if ($CpNb[$login]["CPNumber"] != $cps) {
			$CpNb[$login] = array ("CPNumber" => 0,
								"Time" => '');
			cplive_list($lambda);
	}
  }

  //onPlayerManialinkPageAnswer: [0]=PlayerUid(server), [1]=Login, [2]=Answer
  function cplive_player_answer_hs($lambda, $click){
    global $Players;
	global $answer_1, $answer_2;
	global $add_to_login;
	
    $login = $click[1] . $add_to_login;
    $answer = $click[2];

    if ($answer == $answer_1) {
        $Players[$login]["Manialink"] = 0;
        
		display_hud($lambda);

	$lambda->console('[CP Live] player ('.substr_replace($login, "", -1).') hide CP Live Widget');
   	}
    
    if ($answer == $answer_2) {
        $Players[$login]["Manialink"] = 1;
        
		display_hud($lambda);

	$lambda->console('[CP Live] player ('.substr_replace($login, "", -1).') unhide CP Live Widget');
   	}
  }
      
  //onPlayerInfoChanged
  function cplive_player_afk_spec ($lambda, $c_info){
	global $CpNb;
	global $add_to_login;

	$login = $c_info["Login"] . $add_to_login;
	$status = $c_info["SpectatorStatus"];
	
	if ($status != 0){
		$CpNb[$login] = array ("CPNumber" => 0,
							"Time" => '');
	}
  }

  //onEndRound
  function cplive_list_cp_end ($lambda){
    global $ml_id, $mlink_id;
	
	$hud = '<manialinks>';
	$hud .= '<manialink id="'.$ml_id.'" />';
	$hud .= '<manialink id="'.$mlink_id.'" />';
	$hud .= '</manialinks>';
    
	$lambda->client->query("SendDisplayManialinkPage", $hud, 1, false);
  } 

  //onBeginRound    
  function cplive_reset_all($lambda){
    global $CpNb;
	global $add_to_login;

    foreach ($lambda->server->players->player_list as $tpl) {    
             $login = $tpl->login . $add_to_login;
        
    $CpNb[$login] = array("CPNumber" => 0,
						"Time" => '');	
   	}    
	get_cps($lambda);
	cplive_list($lambda);
  }
        
  //onPlayerDisconnect
  function cplive_player_off ($lambda, $info){
    global $Players, $CpNb, $list;
	global $add_to_login;
    
    $login = $info->login . $add_to_login;
    
    unset($Players[$login]);   
    unset($CpNb[$login]);
    unset($list[$login]);

    cplive_list($lambda);
  }
  
  //*** Func ***//
  
  //get track cp's
  function get_cps($lambda){
	global $all_cps;
	
	$lambda->client->query('GetCurrentChallengeInfo');
    $CCInfo = $lambda->client->getResponse();
    $all_cps = ($CCInfo['NbCheckpoints'])-1; //last cp = finish
  }
    
  //sort 2D array by value
  function subval_sort($a,$subkey){
	
	foreach($a as $k=>$v){
        $b[$k] = strtolower($v[$subkey]);
    }
    arsort($b);    //numbers
    foreach($b as $k=>$v){
                $c[] = $a[$k];
    }
    return $c;
  }

  //format time
  function format_time($ms){
    
	$sec = floor($ms/1000);
    $hun = ($ms - ($sec * 1000)) / 10;
    $min = floor ($sec / 60);
    $_sec = $sec % 60;

    $time = sprintf('%02d:%02d.%02d', $min, $_sec, $hun);
    return $time;
  }
  
  //update List
  function cplive_list($lambda){
	global $Players, $CpNb;
	global $num_rows;
	global $list, $List;

    //copy array
    $List = $list = array_merge_recursive($Players, $CpNb);
  
    //show only when array is not empty (?!)
    if (empty($list) == array()){
  
    //sort by highest curr cp nuber
    $List = subval_sort($List, "CPNumber"); 
  
    //number of rows for displaying
    $List = array_slice($List, 0, $num_rows);
   	}
   	display_hud($lambda);
  }
  
  //display hud
  function display_hud($lambda){
    global $Players;
	
    foreach ($Players as $key=>$hud){

		$login = $key;
		
		if($Players[$login]["Manialink"] == 1){
		title_row($lambda, $login);
		display_hud_on($lambda, $login);
        }
    
        if($Players[$login]["Manialink"] == 0){
		display_hud_off($lambda, $login);
        }
    }
  }
  
  //Title row
  function title_row($lambda, $login){
	global $all_cps, $Players;
	global $xframe, $yframe, $num_rows, $ml_id, $bck_quad, $answer_1;
	global $colour1, $colour2, $colour3;
		
	$hud = '<?xml version="1.0" encoding="UTF-8"?>';
    $hud .= '<manialink id="'.$ml_id.'">';
    $hud .= '<frame scale="1" posn="'.$xframe.' '.$yframe.'">';
    $hud .= '<quad posn="0 0 0" sizen="21 2 0.08" halign="left" valign="center" style="BgsPlayerCard" substyle="BgCard" />';
    $hud .= '<label scale="0.45" posn="0.4 0.1 0.1" halign="left" valign="center" style="TextRaceMessage" text="$'.$colour1.' Checkpoints Live"/>';    
    $hud .= '<label scale="0.45" posn="11 0.1 0.1" halign="left" valign="center" style="TextRaceMessage" text="$'.$colour2.'Track cp\'s:"/>'; 
    $hud .= '<label scale="0.45" posn="17.5 0.1 0.1" halign="center" valign="center" style="TextRaceMessage" text="$'.$colour3.''.$all_cps.'"/>'; 
//22.7.2012 nov host
	$hud .= '<quad posn="19 0 0.12" sizen="1.8 1.8" halign="left" valign="center"
	image="https://dl.dropbox.com/u/93255455/sdl.png"
	imagefocus="https://dl.dropbox.com/u/93255455/rdl.png" action="'.$answer_1.'"/>';
    
	if ($bck_quad){
			
		$rows = count($Players, 0);

		if ($rows >= $num_rows){
			$qheight = ($num_rows * 1.8) + 0.6;
			}else{
			$qheight = ($rows * 1.8) + 0.6;
		}
			$hud .= '<quad posn="0 -0.7 0" sizen="21 '.$qheight.' 0.08" halign="left" valign="top" style="Bgs1InRace" substyle="NavButton"/>';				
	}
		
	$hud .= '</frame>';
	$hud .= '</manialink>';
	
    $lambda->client->query("SendDisplayManialinkPageToLogin", substr_replace($login, "", -1), $hud, 0, false);
  }
    
  //display hud manialink = 1 (unhide)
  function display_hud_on($lambda, $login){      
    global $List;
    global $all_cps;
    global $xframe, $yframe, $mlink_id;
    global $colour4, $colour5, $colour6, $colour7;

	$hud = '<manialink id="'.$mlink_id.'">';
		
	$pid = 1;
    
    //vertical position (players)
    $y = $yframe - 1.9;
    
    //replace Capitals ($t), wide ($w), bold ($o), italic($i), shadow($s), double-quote(")
    $replace_a = array('$t','$w','$o','$i','$s','"');
    $replace_b = array("","","","","","''");
    
        foreach ($List as $tcp){

            $hud .= '<frame scale="1" posn="'.$xframe.' '.$y.'">';
            $hud .= '<label scale="0.48" posn="0.3 0.1 0.1" halign="left" valign="center" style="TextRaceMessage" text="$'.$colour4.''.str_pad($pid, 2, '0', STR_PAD_LEFT).'"/>';  
            
            if (($tcp["CPNumber"]-1) == $all_cps){
                $hud .= '<label scale="0.48" posn="1.8 0.1 0.1" halign="left" valign="center" style="TextRaceMessage" text="$'.$colour5.'CP-"/>';
                $hud .= '<quad posn="4 0 0" sizen="1.6 1.6" halign="left" valign="center" style="BgRaceScore2" substyle="Warmup"/>';
            
			}else{
            
			$hud .= '<label scale="0.48" posn="1.8 0.1 0.1" halign="left" valign="center" style="TextRaceMessage" text="$'.$colour5.'CP-$'.$colour6.''.$tcp["CPNumber"].'"/>';
            }
            
            $hud .= '<label scale="0.48" posn="10.4 0.1 0.1" halign="right" valign="center" style="TextRaceMessage" text="$'.$colour7.''.format_time($tcp["Time"]).'"/>';
            $hud .= '<label scale="0.48" posn="10.6 0.1 0.1" sizen="21 2" halign="left" valign="center" style="TextRaceMessage" text="'.str_ireplace($replace_a, $replace_b, trim($tcp["Nickname"])).'"/>';
            $hud .= '</frame>';
            $y -= 1.8;
               $pid++;
	}
        
    $hud .= '</manialink>';
    $lambda->client->query("SendDisplayManialinkPageToLogin", substr_replace($login, "", -1), $hud, 0, false);
  }
  
  //display hud when manialink = 0 (hide)
  function display_hud_off($lambda, $login){      
    global $xframe, $yframe, $ml_id, $mlink_id, $answer_2;
    global $colour8;

   	$hud = '</manialinks>';
	$hud .= '<manialink id="'.$mlink_id.'" />';
	
	$hud .= '<manialink id="'.$ml_id.'">';
    $hud .= '<frame scale="1" posn="'.$xframe.' '.$yframe.'">';
    $hud .= '<quad posn="0 0 0" sizen="6.8 2 0.08" halign="left" valign="center" style="BgsPlayerCard" substyle="BgCard" />';
    $hud .= '<label scale="0.45" posn="0.4 0.1 0.1" halign="left" valign="center" style="TextRaceMessage" text="$'.$colour8.' CP Live"/>';
//22.7.2012 nov host
    $hud .= '<quad posn="4.9 0 0.12" sizen="1.8 1.8 " halign="left" valign="center" image="https://dl.dropbox.com/u/93255455/sdd.png" imagefocus="https://dl.dropbox.com/u/93255455/zdd.png" action="'.$answer_2.'"/>';    
	$hud .= '</frame>';
    $hud .= '</manialink>';
	$hud .= '</manialinks>';
	
    $lambda->client->query("SendDisplayManialinkPageToLogin", substr_replace($login, "", -1), $hud, 0, false);
  }
  
  ?>
